% December 2019
% Developed by TeSA and CNES (France, Toulouse)
% contact
%   corinne.mailhes@tesa.prd.fr
%   amandine.guillot@cnes.fr
%
% Description : useful for model fitting

function [g,der_g] = slope_plus_noise_gamma(theta,u,fnorm_begin_slope)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

%theta = [gamma alpha sigma2]
% u = log(f)
log_fnorm_begin_slope = log ( fnorm_begin_slope );
tmp1 = exp(-theta(2)*(u-log_fnorm_begin_slope));
%Function
g = log(theta(3)) + log( 1 + theta(1)*tmp1 );

% RAJOUT corinne 2019-01-10
% Voir rapport Lot 3 du 10/11/2017, page 2 pour expression modele
% Equation 3
% on n'a mis ici que la partie valable pour f > fnorm_begin_slope
% il faut corriger pour les frequences precedentes
% indice du tableau de frequences correspondant au debut de la pente (on
% doit pouvoir faire mieux)
ind_fbegin_slope = sum( u < log_fnorm_begin_slope);
% signifie que tab_log_fnorm(ind_fbegin_slope) < log_fnorm_begin_slope < tab_log_fnorm(ind_fbegin_slope +1)
% on rectifie si log_fnorm_begin_slope est plus proche de indice suivant
if abs( u(ind_fbegin_slope +1)-log_fnorm_begin_slope) < abs(log_fnorm_begin_slope - u(ind_fbegin_slope)),
    % on met des abs pour pas se tromper... (ce sont des valeurs de log
    % donc negatives)
    ind_fbegin_slope = ind_fbegin_slope +1;
end
g(1 : ind_fbegin_slope) = g(ind_fbegin_slope)*ones(size(g(1 : ind_fbegin_slope)));
% on a fait le plateau
% fin RAJOUT corinne

%Derivative
if nargout > 1
    tmp2 = tmp1./(1+theta(1)*tmp1);
    der_g(:,1) = tmp2;
    der_g(:,2) = -theta(1)*(u-log_fnorm_begin_slope).*tmp2;
    der_g(:,3) = 1/theta(3);
end